#pragma once
#include <fstream>
#include <cstdlib>
#include <ctime>
#include <string>
#include <iterator>
#include <vector>
#include <algorithm>
#include <numeric>



void createData(const std::string&);

void _createData(const std::string& file);

template<typename type>
type loadData(const std::string& file)
{
    std::ifstream i_f(file);
    std::istream_iterator<int> iter(i_f);
    std::istream_iterator<int> end;

    type cont;

    for (; iter != end; iter++)
    {
        cont.push_back(*iter);
    }

    i_f.close();
    return cont;
}


template<typename type>
type _loadData(const std::string& file)
{
    std::ifstream i_f(file);
    std::istream_iterator<int> iter(i_f);
    std::istream_iterator<int> end; 

    type cont;

    std::back_insert_iterator<type> back_iter(cont);

    std::copy(iter, end, back_iter);

    i_f.close();
    return cont;
}

template<typename type>
type modify_1(const std::string& file)
{
    type cont = _loadData<type>(file);
    int max = *(std::max_element(cont.begin(), cont.end()));

    for (auto& el : cont)
    {
        if (el > 0)
            el = max;
    }

    
    int sum = std::accumulate(cont.begin(), cont.end(),0);

    int sumAbs = 0;
    for (auto& el : cont)
    {
        sumAbs += std::fabs((el));
    }


    std::ofstream of("new.txt");
    std::ostream_iterator<int> iter(of," ");
    

    std::copy(cont.begin(), cont.end(), iter);

    of.close();

    remove(file.c_str());
    rename("new.txt", file.c_str());

    cont.push_back(sum);
    cont.push_back(sumAbs / (cont.size() - 1));

    return cont;
}

void modify_2(const std::istream_iterator<int> first, const std::istream_iterator<int> last);

void modify_3(const std::string& file);

void modify_4(const std::string& file);


template<typename type>
void outputResult(const std::string& fileName, const type& cont)
{
    std::ofstream of(fileName);
    for (auto& el : cont)
        of << el <<" ";

    of.close();
}

template<typename type>
void _outputResult(const std::string& fileName, const type& cont)
{
    std::ofstream of(fileName);
    std::ostream_iterator<int> iter(of, " ");

    std::copy(cont.begin(), cont.end(), iter);

    of.close();
}


